<?php

/**
 *
 * 
 *
 * Generated by <a href="http://enunciate.codehaus.org">Enunciate</a>.
 *
 */
 

namespace It\Polimi\Hegira\Api;

/**
 * 
 */
class ZKobject
{

    /**
     * The lower extreme of the generated range of unique ids.
     *
     * @var string
     */
    private $lowExtreme;

    /**
     * The highest extreme of the generated range of unique ids.
     *
     * @var string
     */
    private $highExtreme;

    /**
     * The generated unique id.
     *
     * @var string
     */
    private $id;

    /**
     * The status given in response to the REST request.
     *
     * @var \It\Polimi\Hegira\Api\Status
     */
    private $requestStatus;

    /**
     * Constructs a ZKobject from a (parsed) JSON hash
     *
     * @param mixed $o Either an array (JSON) or an XMLReader.
     */
    public function __construct($o = null)
    {
        if (is_array($o)) {
            $this->initFromArray($o);
        }
        else if ($o instanceof \XMLReader) {
            $success = true;
            while ($success && $o->nodeType != \XMLReader::ELEMENT) {
                $success = $o->read();
            }
            if ($o->nodeType != \XMLReader::ELEMENT) {
                throw new \Exception("Unable to read XML: no start element found.");
            }

            $this->initFromReader($o);
        }
    }

    /**
     * The lower extreme of the generated range of unique ids.
     *
     * @return string
     */
    public function getLowExtreme()
    {
        return $this->lowExtreme;
    }

    /**
     * The lower extreme of the generated range of unique ids.
     *
     * @param string $lowExtreme
     */
    public function setLowExtreme($lowExtreme)
    {
        $this->lowExtreme = $lowExtreme;
    }
    /**
     * The highest extreme of the generated range of unique ids.
     *
     * @return string
     */
    public function getHighExtreme()
    {
        return $this->highExtreme;
    }

    /**
     * The highest extreme of the generated range of unique ids.
     *
     * @param string $highExtreme
     */
    public function setHighExtreme($highExtreme)
    {
        $this->highExtreme = $highExtreme;
    }
    /**
     * The generated unique id.
     *
     * @return string
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * The generated unique id.
     *
     * @param string $id
     */
    public function setId($id)
    {
        $this->id = $id;
    }
    /**
     * The status given in response to the REST request.
     *
     * @return \It\Polimi\Hegira\Api\Status
     */
    public function getRequestStatus()
    {
        return $this->requestStatus;
    }

    /**
     * The status given in response to the REST request.
     *
     * @param \It\Polimi\Hegira\Api\Status $requestStatus
     */
    public function setRequestStatus($requestStatus)
    {
        $this->requestStatus = $requestStatus;
    }
    /**
     * Returns the associative array for this ZKobject
     *
     * @return array
     */
    public function toArray()
    {
        $a = array();
        if ($this->lowExtreme) {
            $a["lowExtreme"] = $this->lowExtreme;
        }
        if ($this->highExtreme) {
            $a["highExtreme"] = $this->highExtreme;
        }
        if ($this->id) {
            $a["id"] = $this->id;
        }
        if ($this->requestStatus) {
            $a["requestStatus"] = $this->requestStatus->toArray();
        }
        return $a;
    }

    /**
     * Returns the JSON string for this ZKobject
     *
     * @return string
     */
    public function toJson()
    {
        return json_encode($this->toArray());
    }

    /**
     * Initializes this ZKobject from an associative array
     *
     * @param array $o
     */
    public function initFromArray($o)
    {
        if (isset($o['lowExtreme'])) {
            $this->lowExtreme = $o["lowExtreme"];
        }
        if (isset($o['highExtreme'])) {
            $this->highExtreme = $o["highExtreme"];
        }
        if (isset($o['id'])) {
            $this->id = $o["id"];
        }
        if (isset($o['requestStatus'])) {
            $this->requestStatus = new \It\Polimi\Hegira\Api\Status($o["requestStatus"]);
        }
    }

    /**
     * Initializes this ZKobject from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of ZKobject from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'lowExtreme') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->lowExtreme = $child;
            $happened = true;
        }
        else if (($xml->localName == 'highExtreme') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->highExtreme = $child;
            $happened = true;
        }
        else if (($xml->localName == 'id') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->id = $child;
            $happened = true;
        }
        else if (($xml->localName == 'requestStatus') && (empty($xml->namespaceURI))) {
            $child = new \It\Polimi\Hegira\Api\Status($xml);
            $this->requestStatus = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of ZKobject from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes this ZKobject to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'ZKobject', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this ZKobject to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->lowExtreme) {
            $writer->startElementNs(null, 'lowExtreme', null);
            $writer->text($this->lowExtreme);
            $writer->endElement();
        }
        if ($this->highExtreme) {
            $writer->startElementNs(null, 'highExtreme', null);
            $writer->text($this->highExtreme);
            $writer->endElement();
        }
        if ($this->id) {
            $writer->startElementNs(null, 'id', null);
            $writer->text($this->id);
            $writer->endElement();
        }
        if ($this->requestStatus) {
            $writer->startElementNs(null, 'requestStatus', null);
            $this->requestStatus->writeXmlContents($writer);
            $writer->endElement();
        }
    }
}

namespace It\Polimi\Hegira\Api;

/**
 * 
 */
class Status
{

    /**
     * OK, WARNING or ERROR.
     *
     * @var string
     */
    private $State;

    /**
     * 
     *
     * @var string
     */
    private $message;

    /**
     * 
     *
     * @var string
     */
    private $error_code;

    /**
     * Constructs a Status from a (parsed) JSON hash
     *
     * @param mixed $o Either an array (JSON) or an XMLReader.
     */
    public function __construct($o = null)
    {
        if (is_array($o)) {
            $this->initFromArray($o);
        }
        else if ($o instanceof \XMLReader) {
            $success = true;
            while ($success && $o->nodeType != \XMLReader::ELEMENT) {
                $success = $o->read();
            }
            if ($o->nodeType != \XMLReader::ELEMENT) {
                throw new \Exception("Unable to read XML: no start element found.");
            }

            $this->initFromReader($o);
        }
    }

    /**
     * OK, WARNING or ERROR.
     *
     * @return string
     */
    public function getState()
    {
        return $this->State;
    }

    /**
     * OK, WARNING or ERROR.
     *
     * @param string $State
     */
    public function setState($State)
    {
        $this->State = $State;
    }
    /**
     * 
     *
     * @return string
     */
    public function getMessage()
    {
        return $this->message;
    }

    /**
     * 
     *
     * @param string $message
     */
    public function setMessage($message)
    {
        $this->message = $message;
    }
    /**
     * 
     *
     * @return string
     */
    public function getError_code()
    {
        return $this->error_code;
    }

    /**
     * 
     *
     * @param string $error_code
     */
    public function setError_code($error_code)
    {
        $this->error_code = $error_code;
    }
    /**
     * Returns the associative array for this Status
     *
     * @return array
     */
    public function toArray()
    {
        $a = array();
        if ($this->State) {
            $a["status"] = $this->State;
        }
        if ($this->message) {
            $a["message"] = $this->message;
        }
        if ($this->error_code) {
            $a["error_code"] = $this->error_code;
        }
        return $a;
    }

    /**
     * Returns the JSON string for this Status
     *
     * @return string
     */
    public function toJson()
    {
        return json_encode($this->toArray());
    }

    /**
     * Initializes this Status from an associative array
     *
     * @param array $o
     */
    public function initFromArray($o)
    {
        if (isset($o['status'])) {
            $this->State = $o["status"];
        }
        if (isset($o['message'])) {
            $this->message = $o["message"];
        }
        if (isset($o['error_code'])) {
            $this->error_code = $o["error_code"];
        }
    }

    /**
     * Initializes this Status from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of Status from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'status') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->State = $child;
            $happened = true;
        }
        else if (($xml->localName == 'message') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->message = $child;
            $happened = true;
        }
        else if (($xml->localName == 'error_code') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->error_code = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of Status from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes this Status to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'status', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this Status to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->State) {
            $writer->startElementNs(null, 'status', null);
            $writer->text($this->State);
            $writer->endElement();
        }
        if ($this->message) {
            $writer->startElementNs(null, 'message', null);
            $writer->text($this->message);
            $writer->endElement();
        }
        if ($this->error_code) {
            $writer->startElementNs(null, 'error_code', null);
            $writer->text($this->error_code);
            $writer->endElement();
        }
    }
}
